/*
  Copyright (C) 2003 Laurent Martelli <laurent@aopsys.com>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

package org.objectweb.jac.aspects.gui;

import java.util.HashSet;
import org.objectweb.jac.core.rtti.CollectionItem;
import org.objectweb.jac.core.rtti.FieldItem;
import org.objectweb.jac.core.rtti.MemberItem;

/**
 * Defines a generic member view (is embedded, ...)
 */
public class CollectionItemView extends MemberItemView {
   public CollectionItemView(CollectionItem collection, String viewName) {
      super(collection,viewName);
   }

   boolean embeddedAdded;
   public void setEmbeddedAdded(boolean embedded) {
      this.embeddedAdded = embedded;
   }
   public boolean isEmbeddedAdded() {
      return embeddedAdded;
   }

   HashSet embeddedEditorColumns = new HashSet();
   boolean embeddedEditors = false;
   public void setEmbeddedEditors(boolean embeddedEditors) {
      this.embeddedEditors = embeddedEditors;
   }
   public void addEmbeddedEditorColumn(MemberItem field) {
      embeddedEditorColumns.add(field);
   }
   public boolean isEmbeddedEditors(MemberItem field) {
      return embeddedEditors || embeddedEditorColumns.contains(field);
   }
   public boolean isEmbeddedEditors() {
      return embeddedEditors;
   }
}
