/*
  Copyright (C) 2002-2003 Laurent Martelli <laurent@aopsys.com>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

package org.objectweb.jac.aspects.gui.web;

import org.objectweb.jac.aspects.gui.*;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * An HTML page containing a View and a close button.
 */
public class Page extends AbstractPage implements WindowListener
{

   public Page(View view,boolean newWindow) {
      super(view,newWindow);
   }

   // HTMLViewer interface
   public void genBody(PrintWriter out) throws IOException {
      ((HTMLViewer)view).genHTML(out);
      out.println("  <div class=\"actions\">");
      if(newWindow) {
         out.println("    <a class=\"button\" onClick=\"javascript:window.close();\">"+GuiAC.getLabelClose()+"</a>");
      } else {
         out.println("    <a class=\"button\" href=\""+eventURL("onClose")+"\">"+GuiAC.getLabelClose()+"</a>");
      }
      out.println("  </div>");
   }

   // WindowListener interface

   public void onClose() {
      ((WebDisplay)context.getDisplay()).closeWindow(this);
      ((WebDisplay)context.getDisplay()).refresh();
   }
}
