/*
  Copyright (C) 2001-2003 Lionel Seinturier <Lionel.Seinturier@lip6.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package org.objectweb.jac.samples.hibernate;

/**
 * @author Lionel Seinturier <Lionel.Seinturier@lip6.fr>
 * @version 1.0
 */
public class User {
    
    private String id = "";
    private String name = "";
    private int age;
    
    public static void main( String[] args ) throws Exception {
        User bob = new User();
        test1(bob);
    }
    
    public static void test1(User bob) {
        
        System.out.println("Initial age for bob (alias user0) is: " + bob.age );        
        bob.age++;
        System.out.println("Final age for bob (alias user0) is: " + bob.age );        
    }

	public User() {}
    public User( String id, String name, int age ) {
        this.id = id;
        this.name = name;
        this.age = age;
    }
    
    /**
	 * @return
	 */
	public int getAge() {
		return age;
	}

	/**
	 * @return
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param i
	 */
	public void setAge(int i) {
		age = i;
	}

	/**
	 * @param i
	 */
	public void setId(String i) {
		id = i;
	}

	/**
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}
    
    public String toString() {
        return super.toString()+" [id: "+id+"; name: "+name+"; age: "+age+"]";
    }

}
